import React from 'react';
import { Input, InputNumber, Button, Form, Icon, Spin, message, Table, Modal, Upload, Select } from 'antd';
import { beforeUploadFile, newDownloadFile } from '../../../../tools.js';
import './hrSituation.less'
import ajax from 'jquery/src/ajax/xhr.js'
import $ from 'jquery/src/ajax';


const HrSituationDescFrom = Form.create()(React.createClass({
    getInitialState() {
        return {
            loading: false,
            yearOption: []
        };
    },
    componentWillMount() {
        let d = new Date();
        let _me = this;
        d = d.getFullYear();
        for (let i = d; i > d - 20; i--) {
            _me.state.yearOption.push(
                <Select.Option value={i.toString()} key={i}>{i}</Select.Option>
            )
        }
    },
    handleSubmit(e) {
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (values.firmTotal < values.firmInService + values.firmPartTime + values.firmTemporary) {
                message.warning("总体情况的在职人员数、兼职人员数、临时聘用人员数相加小于等于企业职工总数!");
                return;
            };
            if (values.firmTotal < values.techTotal) {
                message.warning("科技人员数小于等于企业职工总数!");
                return;
            };
            if (values.firmInService < values.techInService || values.firmPartTime < values.techPartTime || values.firmTemporary < values.techTemporary ||
                values.firmForeign < values.techForeign || values.firmAbroad < values.techAbroad || values.firmCore < values.techCore) {
                message.warning("科技人员各项人数小于等于企业职工各项人数!");
                return;
            };
            if (values.firmTotal < values.doctor + values.master + values.undergraduate + values.college) {
                message.warning("全体人员结构中学历一栏人数总和小于等于职工人数!");
                return;
            };
            if (values.firmTotal < values.belowThirty + values.thirtyoneToThirtyfour + values.fortyoneToFifty + values.aboveFifty) {
                message.warning("全体人员结构中年龄一栏人数总和小于等于职工人数!");
                return;
            };
            if (!this.state.year && !this.props.data.year) {
                message.warning("请输入年份!");
                return;
            };
            if (!err) {
                this.props.spinState(true);
                $.ajax({
                    method: "POST",
                    dataType: "json",
                    crossDomain: false,
                    url: globalConfig.context + "/api/admin/updateOrgHumanResource",
                    data: {
                        id: this.props.data.id,
                        uid: this.props.uid,
                        year: this.state.year || this.props.data.year,
                        aboveFifty: values.aboveFifty,
                        belowThirty: values.belowThirty,
                        college: values.college,
                        doctor: values.doctor,
                        firmAbroad: values.firmAbroad,
                        firmCore: values.firmCore,
                        firmForeign: values.firmForeign,
                        firmInService: values.firmInService,
                        firmPartTime: values.firmPartTime,
                        firmTemporary: values.firmTemporary,
                        firmTotal: values.firmTotal,
                        fortyoneToFifty: values.fortyoneToFifty,
                        intermediateTitle: values.intermediateTitle,
                        juniorTitle: values.juniorTitle,
                        master: values.master,
                        seniorMechanic: values.seniorMechanic,
                        seniorTitle: values.seniorTitle,
                        techAbroad: values.techAbroad,
                        techCore: values.techCore,
                        techForeign: values.techForeign,
                        techInService: values.techInService,
                        techPartTime: values.techPartTime,
                        techTemporary: values.techTemporary,
                        techTotal: values.techTotal,
                        thirtyoneToThirtyfour: values.thirtyoneToThirtyfour,
                        undergraduate: values.undergraduate,
                        rosterUrl: this.state.rosterUrl,
                        socialSecurityUrl: this.state.socialSecurityUrl,
                        newEmployment: values.newEmployment,
                        graduateNumber: values.graduateNumber
                    }
                }).done(function (data) {
                    if (!data.error.length) {
                        message.success('保存成功！');
                        this.props.clickOk();
                        this.props.spinState(false);
                        this.props.form.resetFields();
                    } else {
                        message.warning(data.error[0].message);
                        this.props.spinState(false);
                    }
                }.bind(this));
            }
        });
    },
    componentWillReceiveProps(nextProps) {
        if (!this.props.visible && nextProps.visible) {
            this.props.form.resetFields();
        };
    },
    render() {
        const { getFieldDecorator } = this.props.form;
        const formItemLayout = {
            labelCol: { span: 8 },
            wrapperCol: { span: 16 },
        };
        const FormItem = Form.Item;
        const theData = this.props.data;
        return (
            <Form onSubmit={this.handleSubmit} className="hrSituation-form">
                <div className="clearfix">
                    <div className="activityCost-title"><span>年份: </span>
                        {
                            theData.year ? <span>{theData.year}</span> :
                                <Select placeholder="请选择年份" style={{ width: 200 }}
                                    onSelect={(e, n) => { this.state.year = e }}>
                                    {this.state.yearOption}
                                </Select>
                        }
                    </div>
                </div>
                <p className="hrSituation-title">总体情况</p>
                <div className="clearfix">
                    <span className="hrSituation-span">总数（人）</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="企业职工"
                    >
                        {getFieldDecorator('firmTotal', {
                            initialValue: this.props.data.firmTotal || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="科技人员"
                    >
                        {getFieldDecorator('techTotal', {
                            initialValue: this.props.data.techTotal || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item" style={{ width: '50%' }}>
                        <span>其中科技人员占比
                        {(() => {
                                if (!this.props.form.getFieldValue('techTotal') || !this.props.form.getFieldValue('firmTotal')) {
                                    return 0
                                }
                                return (this.props.form.getFieldValue('techTotal') / this.props.form.getFieldValue('firmTotal') * 100).toFixed(2)
                            })()}
                            %</span>
                    </FormItem>
                    <span className="hrSituation-span">在职人员（人）</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="企业职工"
                    >
                        {getFieldDecorator('firmInService', {
                            initialValue: this.props.data.firmInService || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="科技人员"
                    >
                        {getFieldDecorator('techInService', {
                            initialValue: this.props.data.techInService || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <span className="hrSituation-span">兼职人员（人）</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="企业职工"
                    >
                        {getFieldDecorator('firmPartTime', {
                            initialValue: this.props.data.firmPartTime || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="科技人员"
                    >
                        {getFieldDecorator('techPartTime', {
                            initialValue: this.props.data.techPartTime || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <span className="hrSituation-span">临时聘用人员（人）</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="企业职工"
                    >
                        {getFieldDecorator('firmTemporary', {
                            initialValue: this.props.data.firmTemporary || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="科技人员"
                    >
                        {getFieldDecorator('techTemporary', {
                            initialValue: this.props.data.techTemporary || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <span className="hrSituation-span">外籍人员（人）</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="企业职工"
                    >
                        {getFieldDecorator('firmForeign', {
                            initialValue: this.props.data.firmForeign || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="科技人员"
                    >
                        {getFieldDecorator('techForeign', {
                            initialValue: this.props.data.techForeign || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <span className="hrSituation-span">留学归国人员（人）</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="企业职工"
                    >
                        {getFieldDecorator('firmAbroad', {
                            initialValue: this.props.data.firmAbroad || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="科技人员"
                    >
                        {getFieldDecorator('techAbroad', {
                            initialValue: this.props.data.techAbroad || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <span className="hrSituation-span">干人计划人员（人）</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="企业职工"
                    >
                        {getFieldDecorator('firmCore', {
                            initialValue: this.props.data.firmCore || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="科技人员"
                    >
                        {getFieldDecorator('techCore', {
                            initialValue: this.props.data.techCore || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                </div>
                <p className="hrSituation-title">全体人员结构</p>
                <div className="clearfix">
                    <span className="hrSituation-span">学历人数</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="博士"
                    >
                        {getFieldDecorator('doctor', {
                            initialValue: this.props.data.doctor || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="硕士"
                    >
                        {getFieldDecorator('master', {
                            initialValue: this.props.data.master || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="本科"
                    >
                        {getFieldDecorator('undergraduate', {
                            initialValue: this.props.data.undergraduate || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="大专及以下"
                    >
                        {getFieldDecorator('college', {
                            initialValue: this.props.data.college || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                </div>
                <div className="clearfix">
                    <span className="hrSituation-span">职称人数</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="高级职称"
                    >
                        {getFieldDecorator('seniorTitle', {
                            initialValue: this.props.data.seniorTitle || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="中级职称"
                    >
                        {getFieldDecorator('intermediateTitle', {
                            initialValue: this.props.data.intermediateTitle || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="初级职称"
                    >
                        {getFieldDecorator('juniorTitle', {
                            initialValue: this.props.data.juniorTitle || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="高级技工"
                    >
                        {getFieldDecorator('seniorMechanic', {
                            initialValue: this.props.data.seniorMechanic || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                </div>
                <div className="clearfix">
                    <span className="hrSituation-span">年龄人数</span>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="30及以下"
                    >
                        {getFieldDecorator('belowThirty', {
                            initialValue: this.props.data.belowThirty || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="31-34"
                    >
                        {getFieldDecorator('thirtyoneToThirtyfour', {
                            initialValue: this.props.data.thirtyoneToThirtyfour || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="41-50"
                    >
                        {getFieldDecorator('fortyoneToFifty', {
                            initialValue: this.props.data.fortyoneToFifty || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem className="half-item"
                        {...formItemLayout}
                        label="50以上"
                    >
                        {getFieldDecorator('aboveFifty', {
                            initialValue: this.props.data.aboveFifty || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                </div>
                <p className="hrSituation-title">每年新增员工数</p>
                <div className="clearfix">
                    <FormItem
                        labelCol={{ span: 16 }}
                        wrapperCol={{ span: 8 }}
                        label="新增就业人数"
                    >
                        {getFieldDecorator('newEmployment', {
                            initialValue: this.props.data.newEmployment || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                    <FormItem
                        labelCol={{ span: 16 }}
                        wrapperCol={{ span: 8 }}
                        label="高校应届毕业生人数"
                    >
                        {getFieldDecorator('graduateNumber', {
                            initialValue: this.props.data.graduateNumber || 0
                        })(
                            <InputNumber />
                            )}
                    </FormItem>
                </div>
                <div className="hrSituation-roster">
                    <Upload
                        name="ratepay"
                        action={globalConfig.context + "/api/admin/uploadRoster"}
                        data={{ 'sign': 'roster','year': (this.state.year || theData.year),'uid': this.props.uid }}
                        beforeUpload={beforeUploadFile}
                        showUploadList={false}
                        onChange={(info) => {
                            if (info.file.status !== 'uploading') {
                                console.log(info.file, info.fileList);
                            }
                            if (info.file.status === 'done') {
                                if (!info.file.response.error.length) {
                                    message.success(`${info.file.name} 文件上传成功！`);
                                } else {
                                    message.warning(info.file.response.error[0].message);
                                    return;
                                };
                                this.state.rosterUrl = info.file.response.data;
                            } else if (info.file.status === 'error') {
                                message.error(`${info.file.name} 文件上传失败。`);
                            }
                        }}
                    >
                        <Button><Icon type="upload" /> 上传花名册 </Button>
                    </Upload>
                    <p style={{ marginTop: '10px' }}>{theData.rosterUrl ? <a onClick={newDownloadFile.bind(null, this.props.data.id, 'roster', '/api/admin/downloadHumanResource')}>{theData.rosterDownloadFileName}</a> : <span><Icon type="exclamation-circle" style={{ color: '#ffbf00', marginRight: '6px' }} />未上传！</span>}</p>
                </div>
                <div className="hrSituation-roster">
                    <Upload
                        name="ratepay"
                        action={globalConfig.context + "/api/admin/uploadSocialSecurity"}
                        data={{ 'sign': 'social_security','year': (this.state.year || theData.year),'uid': this.props.uid }}
                        beforeUpload={beforeUploadFile}
                        showUploadList={false}
                        onChange={(info) => {
                            if (info.file.status !== 'uploading') {
                                console.log(info.file, info.fileList);
                            }
                            if (info.file.status === 'done') {
                                if (!info.file.response.error.length) {
                                    message.success(`${info.file.name} 文件上传成功！`);
                                } else {
                                    message.warning(info.file.response.error[0].message);
                                    return;
                                };
                                this.state.socialSecurityUrl = info.file.response.data;
                            } else if (info.file.status === 'error') {
                                message.error(`${info.file.name} 文件上传失败。`);
                            }
                        }}
                    >
                        <Button><Icon type="upload" /> 上传社保情况 </Button>
                    </Upload>
                    <p style={{ marginTop: '10px' }}>{theData.socialSecurityUrl ? <a onClick={newDownloadFile.bind(null, this.props.data.id, 'social_security', '/api/admin/downloadHumanResource')}>{theData.socialSecurityDownloadFileName}</a> : <span><Icon type="exclamation-circle" style={{ color: '#ffbf00', marginRight: '6px' }} />未上传！</span>}</p>
                </div>
                <div>
                    <span style={{ color: "red" }}>提示</span>
                    <p>1、总体情况的在职人员数、兼职人员数、临时聘用人员数相加小于等于企业职工总数。</p>
                    <p>2、科技人员数小于等于企业职工总数。</p>
                    <p>3、科技人员各项人数小于等于企业职工各项人数。</p>
                    <p>4、全体人员结构中学历一栏人数总和小于等于职工人数。</p>
                    <p>5、全体人员结构中年龄一栏人数总和小于等于职工人数。</p>
                    <Button style={{ marginTop: "20px" }} className="set-submit" type="primary" htmlType="submit">保存</Button>
                </div>
            </Form >
        );
    },
}));

const HrSituationDesc = React.createClass({
    getInitialState() {
        return {
            visible: false,
            loading: false
        };
    },
    componentWillReceiveProps(nextProps) {
        this.state.visible = nextProps.showDesc
    },
    showModal() {
        this.setState({
            visible: true,
        });
    },
    handleOk() {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false, true);
    },
    handleCancel(e) {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false);
    },
    spinChange(e) {
        this.setState({
            loading: e
        });
    },
    render() {
        return (
            <div className="patent-addNew">
                <Spin spinning={this.state.loading} className='spin-box'>
                    <Modal title="人力资源状况" visible={this.state.visible}
                        onOk={this.handleOk} onCancel={this.handleCancel}
                        width='1200px'
                        footer=''
                    >
                        <HrSituationDescFrom
                            uid={this.props.uid}
                            data={this.props.data}
                            spinState={this.spinChange}
                            visible={this.state.visible}
                            closeModal={this.handleCancel}
                            clickOk={this.handleOk} />
                    </Modal>
                </Spin>
            </div>
        );
    },
});

const HrSituation = React.createClass({
    loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/orgHumanResource",
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                uid: this.props.data.uid
            }
        }).done((data) => {
            if (data.error.length || !data.data || !data.data.list) {
                message.warning(data.error[0].message);
                return;
            };
            for (let i = 0; i < data.data.list.length; i++) {
                let thisdata = data.data.list[i];
                this.state.data.push({
                    key: i,
                    id: thisdata.id,
                    uid: thisdata.uid,
                    year: thisdata.year,
                    aboveFifty: thisdata.aboveFifty,
                    belowThirty: thisdata.belowThirty,
                    college: thisdata.college,
                    doctor: thisdata.doctor,
                    firmAbroad: thisdata.firmAbroad,
                    firmCore: thisdata.firmCore,
                    firmForeign: thisdata.firmForeign,
                    firmInService: thisdata.firmInService,
                    firmPartTime: thisdata.firmPartTime,
                    firmTemporary: thisdata.firmTemporary,
                    firmTotal: thisdata.firmTotal,
                    fortyoneToFifty: thisdata.fortyoneToFifty,
                    intermediateTitle: thisdata.intermediateTitle,
                    juniorTitle: thisdata.juniorTitle,
                    master: thisdata.master,
                    seniorMechanic: thisdata.seniorMechanic,
                    seniorTitle: thisdata.seniorTitle,
                    techAbroad: thisdata.techAbroad,
                    techCore: thisdata.techCore,
                    techForeign: thisdata.techForeign,
                    techInService: thisdata.techInService,
                    techPartTime: thisdata.techPartTime,
                    techTemporary: thisdata.techTemporary,
                    techTotal: thisdata.techTotal,
                    thirtyoneToThirtyfour: thisdata.thirtyoneToThirtyfour,
                    undergraduate: thisdata.undergraduate,

                    rosterUrl: thisdata.rosterUrl,
                    rosterDownloadFileName: thisdata.rosterDownloadFileName,
                    socialSecurityUrl: thisdata.socialSecurityUrl,
                    socialSecurityDownloadFileName: thisdata.socialSecurityDownloadFileName,

                    attachment: [thisdata.id, thisdata.rosterDownloadFileName, thisdata.socialSecurityDownloadFileName],

                    newEmployment: thisdata.newEmployment,
                    graduateNumber: thisdata.graduateNumber
                });
            };
            this.state.pagination.current = data.data.pageNo;
            this.state.pagination.total = data.data.totalCount;
            this.setState({
                dataSource: this.state.data,
                pagination: this.state.pagination
            });
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '年份',
                    dataIndex: 'year',
                    key: 'year'
                }, {
                    title: '总人数',
                    dataIndex: 'firmTotal',
                    key: 'firmTotal'
                }, {
                    title: '科技人员',
                    dataIndex: 'techTotal',
                    key: 'techTotal'
                }, {
                    title: '博士人数',
                    dataIndex: 'doctor',
                    key: 'doctor',
                }, {
                    title: '高级职称人数',
                    dataIndex: 'seniorTitle',
                    key: 'seniorTitle',
                }, {
                    title: '30岁以下人数',
                    dataIndex: 'belowThirty',
                    key: 'belowThirty',
                }, {
                    title: '相关附件',
                    dataIndex: 'attachment',
                    key: 'attachment',
                    render: (text) => {
                        return <div>
                            <a style={{ marginRight: '10px' }} onClick={newDownloadFile.bind(null, text[0], 'roster', '/api/admin/downloadHumanResource')}>{text[1]}</a>
                            <a onClick={newDownloadFile.bind(null, text[0], 'social_security', '/api/admin/downloadHumanResource')}>{text[2]}</a>
                        </div>
                    }
                }
            ],
            dataSource: []
        };
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true
        });
    },
    delectRow() {
        let deletedIds = [];
        for (let idx = 0; idx < this.state.selectedRows.length; idx++) {
            let rowItem = this.state.selectedRows[idx];
            if (rowItem.id) {
                deletedIds.push(rowItem.id)
            }
        }
        this.setState({
            selectedRowKeys: [],
            loading: deletedIds.length > 0
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/user/cognizance/deleteFinance",
            data: {
                ids: deletedIds
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('保存成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    closeDesc(e, s) {
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows,
                    selectedRowKeys: selectedRowKeys
                });
            }
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        return (
            <div className="user-content" >
                <div className="content-title">
                    <span>人力资源状况</span>
                </div>
                <div className="user-search">
                    <p>
                        <Button style={{ background: "#ea0862", border: "none", color: "#fff" }}
                            onClick={this.tableRowClick}>添加<Icon type="plus" /></Button>
                        <Button style={{ background: "#3fcf9e", border: "none", color: "#fff" }}
                            disabled={!hasSelected}
                            onClick={this.delectRow}>删除<Icon type="minus" /></Button>
                    </p>
                </div>
                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            dataSource={this.state.dataSource}
                            pagination={this.state.pagination}
                            rowSelection={rowSelection}
                            onRowClick={this.tableRowClick} />
                    </Spin>
                </div>
                <HrSituationDesc
                    uid={this.props.data.uid}
                    data={this.state.RowData}
                    showDesc={this.state.showDesc} closeDesc={this.closeDesc} />
            </div >
        );
    }
});

export default HrSituation;